## gringo 5.1.0

=== SConstruct ===
#!/usr/bin/python
# {{{ GPL License

# This file is part of gringo - a grounder for logic programs.
# Copyright (C) 2013  Roland Kaminski

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# }}}

from os import mkdir
from os.path import join, exists

if not exists("build"): mkdir("build")

AddOption('--build-dir', default='debug', metavar='DIR', nargs=1, type='string', dest='build_dir')
AddOption('--test-case', default=None, metavar='NAME', nargs=1, type='string', dest='test_case')

# Note: workaround for scons limitation (try to get a hand on the internal option parser)

opts_file = join("build", GetOption('build_dir') + ".py")

opts = Variables(opts_file, ARGUMENTS)
opts.AddVariables(
    ('CXX'           , 'C++ compiler'),
    ('CC'            , 'C compiler'),
    ('CXXFLAGS'      , 'C++ compiler flags'),
    ('CFLAGS'        , 'C compiler flags'),
    ('CPPPATH'       , 'include paths'),
    ('CPPDEFINES'    , 'defines'),
    ('LIBS'          , 'additional libraries'),
    ('LIBPATH'       , 'library paths'),
    ('LINKFLAGS'     , 'C++ linker flags'),
    ('CLINKFLAGS'    , 'C linker flags'),
    ('RPATH'         , 'library paths to embedd into binaries'),
    ('AR'            , 'path to ar'),
    ('ARFLAGS'       , 'ar flags'),
    ('RANLIB'        , 'path to ranlib'),
    ('BISON'         , 'path to bison'),
    ('RE2C'          , 'path to re2c'),
    ('PYTHON_CONFIG' , 'path to python-config'),
    ('PKG_CONFIG'    , 'path to pkg-config'),
    ('WITH_PYTHON'   , 'enable python integration; None, "auto", or library name or path'),
    ('WITH_LUA'      , 'enable lua integration; None, "auto", library name, or path'),
    ('WITH_THREADS'  , 'enable thread support in clasp library; "posix", "windows", or None'),
    ('TESTS'         , 'enable specific unit tests; [libgringo, libreify, liblp]'),
    )

env = Environment()
env['BISON']          = 'bison'
env['RE2C']           = 're2c'
env['PYTHON_CONFIG']  = 'python-config'
env['PKG_CONFIG']     = 'pkg-config'
env['CXX']            = 'c++'
env['CC']             = 'cc'
env['CXXFLAGS']       = ['-std=c++11', '-O0', '-g', '-Wall', '-W', '-pedantic', '-fvisibility=hidden']
env['CFLAGS']         = ['-O0', '-g', '-Wall']
env['LIBS']           = []
env['LINKFLAGS']      = ['-std=c++11', '-O0']
env['CLINKFLAGS']     = []
env['CPPDEFINES']     = {}
env['CPPPATH']        = []
env['LIBPATH']        = []
env['RPATH']          = []
env['WITH_PYTHON']    = 'auto'
env['WITH_LUA']       = 'auto'
env['WITH_THREADS']   = 'posix'
env['TESTS']          = ['libreify', 'libgringo', 'libclingo', 'liblp', 'clingo']

if GetOption("build_dir") == "static":
    env['CXXFLAGS'] = ['-std=c++11', '-O3', '-Wall', '-fvisibility=hidden']
    env['CFLAGS'] = ['-O3', '-Wall']
    env['LINKFLAGS'] = ['-std=c++11', '-O3', '-static']
    env['CPPDEFINES']['NDEBUG'] = 1
elif GetOption("build_dir") == "release":
    env['CXXFLAGS']   = ['-std=c++11', '-O3', '-Wall', '-fvisibility=hidden']
    env['CFLAGS'] = ['-O3', '-Wall']
    env['LINKFLAGS']  = ['-std=c++11', '-O3']
    env['CPPDEFINES']['NDEBUG'] = 1
elif GetOption("build_dir") == "js":
    # NOTE: web is the only working target and there is still the .html suffix missing
    env['CXXFLAGS']   = ['-std=c++11', '-Os', '-Wall', '-s', 'DISABLE_EXCEPTION_CATCHING=0']
    env['LINKFLAGS']  = ['-std=c++11', '-Os', '-s', 'DISABLE_EXCEPTION_CATCHING=0', '-s', 'EXPORTED_FUNCTIONS=\'["_run"]\'']
    env['CXX'] = "em++"
    env['AR'] = 'emar'
    env['RANLIB'] = 'emranlib'
    env['CPPDEFINES']['NDEBUG'] = 1
    env['WITH_PYTHON'] = None
    env['WITH_LUA'] = None
    env['WITH_THREADS'] = None

opts.Update(env)
opts.Save(opts_file, env)
opts.FormatVariableHelpText = lambda env, opt, help, default, actual, other: "%10s: %s (%s)\n" % (opt, help, actual)

Help(
"""
usage: scons [OPTION] [TARGET] ...

Options:
  --build-dir=DIR             Sets the build directory to build/DIR. If DIR is
                              release or static then options are set,
                              respectively. Otherwise, debug options are set.
                              Furthermore the special build dir js sets options
                              to build with emscripten. Afterwards, target web
                              can be used to build clingo for the web browser.
                              Default: debug
  --test-case=NAME            Selects which test case to run. If empty all
                              tests will be executed.
                              Default: ''

Targets:
  configure                   Only configure and build nothing.
  gringo                      Build gringo (built by default).
  clingo                      Build clingo (built by default).
  reify                       Build reify (built by default).
  lpconvert                   Build lpconvert (built by default).
  pyclingo                    Python module (built if python support enabled).
  luaclingo                   Lua module (built if lua support enabled).
  test-clingo                 Run clingo specific acceptence tests.
  test-libclingo              Run unit tests for libclingo.
  test-libgringo              Run unit tests for libgringo.
  test-liblp                  Run unit tests for liblp.
  test-libreify               Run unit tests for librefiy.
  libclingo                   Build shared clingo library.
  example                     Build example app using libclingo.
  cexample                    Build example app using clingo's C interface.
  tags                        Generate ctags file.
  web                         Build clingo for the web (use with build-dir js).

Variables:
""" + opts.GenerateHelpText(env))

# Notes to use gold linker:
#   scons --build=gold \
#     CXXFLAGS="-std=c++11 -O4 -Wall" \
#     LINKFLAGS="-O4 -B build/gold/ld-gold/" \
#     RANLIB=true \
#     ARFLAGS="rc --plugin /usr/lib/llvm/LLVMgold.so"

if not env.GetOption('help'):
    SConscript('SConscript', variant_dir=join('build', GetOption('build_dir')), duplicate=0, exports=['env', 'opts'])

=== liblp/tests/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/liblp/ .)
aux_source_directory(. SRC_LIST)
add_executable(test EXCLUDE_FROM_ALL ${SRC_LIST})
target_link_libraries(test liblp)

=== debian/changelog ===
gringo (5.1.0-5) unstable; urgency=medium

  * Bug fix: "FTBFS: libgringo/src/python.cc:348:46: error:
    &#39;*(Gringo::{anonymous}::Object (*)(Gringo::{anonymous}::Reference,
    Gringo::{anonymous}::Reference))Gringo::{anonymous}::createId&#39; is
    not a valid template argument for type
    &#39;Gringo::{anonymous}::Object
    (&amp;)(Gringo::{anonymous}::Reference,
    Gringo::{anonymous}::Reference)&#39;", thanks to Lucas Nussbaum
    (Closes: #871100).
    - debian/control: Build-Depends on g++-6
    - debian/rules: set CONFIGPARMS to CXX='g++-6'
  * debian/copyright: use https instead of http
  * debian/control: Bump Standards-Version to 4.0.1

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 17 Aug 2017 07:18:37 +0200

gringo (5.1.0-4) unstable; urgency=medium

  * fix FTBFS on alpha: do not define FPU_SWITCH_DOUBLE on alpha,
    _FPU_GETCW and friends are undefined on this arch

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 20 Dec 2016 05:10:36 +0100

gringo (5.1.0-3) unstable; urgency=medium

  * debian/rules: fix FTBFS on architectures that require -latomic

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 16 Dec 2016 08:13:33 +0100

gringo (5.1.0-2) unstable; urgency=medium

  * debian/rules: fix C++11 threads
    - link with libatomic on architectures that need it
    - disable threads and define BROKEN_STD_EXCEPTION_PTR on armel
  * gringo-broken-std-exception_ptr.patch: add support for armel

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 15 Dec 2016 06:49:16 +0100

gringo (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * debian/copyright: update copyright year and github source
  * debian/control
    - Build-Depends on g++ >= 4:6.1.1 replaces libtbb-dev
    - point Homepage to https://www.potassco.org
    - use https for Vcs-*
    - add Breaks clasp (<< 3.2.1-1)
  * debian/rules
    - build lpconvert
    - drop libtbb-dev and use c++11 multi-threading
    - disable threads on powerpc,powerpcspe,m68k,mips,mipsel,sh4
  * drop already applied upstream patches: gringo-include-math.patch,
    gringo-solve-multi.patch, gringo-translate-minmax.patch
  * gringo-fix-body-literals-as-auxiliary.patch: add upstream patch
    cherry-picked from d6cfb89df6bbf138ca3e259d71ca7050b322b5d5

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 11 Dec 2016 13:12:35 +0100

gringo (4.5.4-4) unstable; urgency=medium

  * Bug fix: "please make the build reproducible", thanks to
    Reiner Herrmann (Closes: #844096).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 07 Dec 2016 08:27:20 +0100

gringo (4.5.4-3) unstable; urgency=medium

  * Fix gringo-multi-solver.patch: this fixes an FTBFS on architectures
    that have WITH_THREAD=0, i.e., all architectures except amd64 and
    ppc64.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 02 May 2016 07:18:34 +0200

gringo (4.5.4-2) unstable; urgency=medium

  * Bug fix: "FTBFS: error: 'pow' is not a member of 'std'", thanks to
    Martin Michlmayr (Closes: #822383).
  * Add patch to fix random python multithreading segfaults (upstream bug 117)
  * Add patch to fix #min/#max translation bug (upstream bug 119)
  * Build with liblua5.3
  * Bump Standards-Version to 3.9.8

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 01 May 2016 08:47:29 +0200

=== debian/control ===
Source: gringo
Section: interpreters
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 9),
 g++-6 (>= 6.1.1),
 scons,
 re2c,
 bison,
 liblua5.3-dev,
 libpython2.7-dev
Standards-Version: 4.0.1
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/gringo.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/gringo.git
Homepage: https://www.potassco.org/clasp/

Package: gringo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: clasp
Replaces: clingo, iclingo
Conflicts: clingo, iclingo
Breaks:
 aspcud (<= 1.9.0-2),
 clasp (<< 3.2.1-1)
Description: grounding tools for (disjunctive) logic programs
 Current answer set solvers work on variable-free programs. Hence, a
 grounder is needed that, given an input program with first-order
 variables, computes an equivalent ground (variable-free) program.
 .
 This package contains the following tools:
 .
  - gringo: a grounder that, given an input program with first-order
    variables, computes an equivalent ground (variable-free) program in
    aspif format. Its output can be processed further with answer set
    solver clasp. Starting with gringo series 5, its output is no longer
    directly compatible with solvers like smodels or cmodels reading
    smodels format. Use lpconvert for translating aspif format to
    smodels format.
  - clingo: combines both gringo and clasp into a monolithic system.
    This way it offers more control over the grounding and solving
    process than gringo and clasp can offer individually: multi-shot
    solving.
  - lpconvert: converter between gringo's aspif and smodels format.
  - reify: small utility that reifies logic programs given in aspif
    format. It produces a set of facts, which can be processed further
    with gringo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# gringo requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -v -x "(powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# currently, libstdc++ on armel does not support std::exception_ptr, see
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=58938
#
# we define BROKEN_STD_EXCEPTION_PTR below to enable replacement code in
# gringo-broken-std-exception_ptr.patch
broken_exception_ptr = $(shell dpkg-architecture -qDEB_BUILD_ARCH | grep "armel")

# force g++-6
CONFIGPARMS = CXX='g++-6'

# use c++11 threads, lua5.3, and python2.7
ifneq ($(if $(broken_exception_ptr),broken), broken)
	CONFIGPARMS += WITH_THREADS='posix' WITH_LUA='lua5.3' WITH_PYTHON='python2.7' CPPPATH='$${["/usr/include/lua5.3","/usr/include/python2.7"]}'
endif

#
# export CPPFLAGS, CXXFLAGS, and LDFLAGS for scons
#
# default to -O3 -std=c++11 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -std=c++11 -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =

ifeq ($(if $(broken_exception_ptr),broken), broken)
	DEB_CPPFLAGS_MAINT_APPEND += -DBROKEN_STD_EXCEPTION_PTR
endif

ifeq ($(and $(if $(arch),,atomic), $(if $(broken_exception_ptr),,atomic)), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# inject compiler and linker flags to scons variables
SCCXXFLAGS =  $(shell echo $(CXXFLAGS) $(CPPFLAGS) | sed -e 's/^/\$${["/;s/ -/","-/g;s/$$/"]}/')
SCLINKFLAGS = $(shell echo $(LDFLAGS) | sed -e 's/^/\$${["/;s/ -/","-/g;s/$$/"]}/')

%:
	dh $@

# configure with LUA, Python; forcibly turn off threads if std::exception_ptr is broken
override_dh_auto_configure:
	scons configure --build-dir=release $(CONFIGPARMS) CXXFLAGS='$(SCCXXFLAGS)' LINKFLAGS='$(SCLINKFLAGS)' || cat build/release.log build/release.py
ifeq ($(if $(broken_exception_ptr),broken), broken)
	sed -i -e 's/WITH_THREADS =.*/WITH_THREADS = None/' -e 's/WITH_LUA =.*/WITH_LUA = None/' -e 's/WITH_PYTHON =.*/WITH_PYTHON = None/' ./build/release.py
endif

# build gringo clingo reify
override_dh_auto_build:
	scons --build-dir=release gringo clingo reify lpconvert

override_dh_auto_clean:
	rm -rf ./build .sconf_temp .sconsign.dblite

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## gringo 5.2.1

=== debian/changelog ===
gringo (5.2.1-2) unstable; urgency=medium

  * Use pkgkde-symbolshelper to manage C++ symbols
  * debian/rules: use pkgkde_symbolshelper dh addon
  * debian/control: Build-Depends on pkg-kde-tools
  * debian/symbols: use pkgkde-symbolshelper to create C++ symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 03 Nov 2017 06:42:20 +0100

gringo (5.2.1-1) unstable; urgency=medium

  * New upstream version 5.2.1
  * debian/TODO.Debian: list todo items
  * debian/copyright: gringo switched to MIT, and so does the packaging
  * debian/compat: bump debhelper compat level to 10
  * debian/control: use cmake instead of scons
    - force g++-7
    - bump Standards-Version to 4.1.1
    - fix Homepage URI
  * debian/patches: drop various upstream applied patches
    - gringo-alpha-fpu-getcw.patch
    - gringo-broken-std-exception_ptr.patch
    - gringo-fix-body-literals-as-auxiliary.patch
    - reproducible-build.patch
  * debian/install: add libclingo library
  * debian/gringo.links: add ldconfig symlinks for libclingo.so.1.0
  * debian/symbols: add libclingo.so.1 symbols
  * debian/rules: use cmake without rpath and force g++-7
  * Bug fix: "FTBFS: cat: build/release.log: No such file or directory",
    thanks to Lucas Nussbaum (Closes: #880287).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 01 Nov 2017 15:30:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: gringo
 Section: interpreters
-Priority: extra
+Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-Build-Depends: debhelper (>= 9),
- g++-6 (>= 6.1.1),
- scons,
+Build-Depends: debhelper (>= 10),
+ dpkg-dev (>= 1.16.1~),
+ pkg-kde-tools,
+ g++-7 (>= 7.2.0),
+ cmake (>= 3.9.3),
  re2c,
  bison,
  liblua5.3-dev,
  libpython2.7-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/gringo.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/gringo.git
-Homepage: https://www.potassco.org/clasp/
+Homepage: https://www.potassco.org/clingo/
 
 Package: gringo
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# gringo requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on armel, powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr -LAH -DCMAKE_SKIP_RPATH=YES -DCLINGO_MANAGE_RPATH=OFF -DLIB_POTASSCO_BUILD_APP=ON -DCLASP_BUILD_APP=OFF -DCLASP_BUILD_TESTS=OFF -DCLASP_BUILD_EXAMPLES=OFF -DCLINGO_BUILD_EXAMPLES=OFF -DCLINGO_BUILD_TESTS=OFF
TOPBUILDDIR = build/$(CONFIG)_mt

#
# export CXXFLAGS and LDFLAGS for cmake
#
# add -O3 and NDEBUG and enable all hardening flags
# link with libatomic on architectures without built-in atomic
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#
# export CPPFLAGS, CXXFLAGS, and LDFLAGS for scons
#
# default to -O3 -Wall -DNDEBUG and enable all hardening flags
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -Wall
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# force g++-7
export CXX = g++-7
export CC = gcc-7
# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --with pkgkde_symbolshelper

# configure with cmake
override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(TOPBUILDDIR) -- $(CONFIGPARMS)

# build binaries in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(TOPBUILDDIR)

# install CHANGES.md as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/$(TOPBUILDDIR)/bin
